﻿Imports System.IO

Public Class Form1

    Public Class OptionItem
        Public Name As String
        Public TextControl As TextBox
    End Class

    Public Text_Boxes As New List(Of OptionItem)
    Public Group_Boxes As New List(Of GroupBox)

    Private y_Item As Integer
    Private Copied As Boolean

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        LoadOptions()
        SupprtType.SelectedIndex = 0
    End Sub

    Private Sub LoadOptions()
        '@Line Problem
        'Alternate Phone Number|3
        Dim f_options As New StreamReader(Application.StartupPath + "\options.txt")
        Try
            Dim line As String
            Do While Not f_options.EndOfStream
                line = f_options.ReadLine
                If line.Trim = "" Then Continue Do
                If line.StartsWith("#") Then Continue Do
                If line.StartsWith("@") Then
                    CreateGroup(line.Remove(0, 1))
                    Continue Do
                End If
                Try
                    If Not line.Contains("|") Then
                        MsgBox("Missing line numbering in options.txt file, add ""|1"" to line:" + line)
                        Exit Do
                    End If
                    Dim Options = line.Split("|")
                    CreateItem(Options(0), Options(1))
                Catch ex As Exception
                    MsgBox("Fault in options.txt file: " + line)
                    Exit Do
                End Try
            Loop
        Catch ex As Exception
            MsgBox("Error in startup please check options.txt file")
        Finally
            f_options.Close()
            f_options.Dispose()
        End Try
    End Sub

    Private Sub CreateGroup(ByVal Name As String)
        'Create in drop down
        Me.SupprtType.Items.Add(Name)

        'Create Box
        Dim Box As New GroupBox()
        Box.Anchor = (AnchorStyles.Bottom Or AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top)
        'Box.Text = Name
        Box.Location = New Point(12, 44)
        Box.Width = Me.Width - 50
        Box.Height = Me.Height - 100
        Box.Visible = (Group_Boxes.Count = 0)
        Group_Boxes.Add(Box)
        Me.Controls.Add(Box)
        y_Item = 19
    End Sub

    Private Sub CreateItem(ByVal Name As String, ByVal Size As String)
        Dim box As GroupBox = Group_Boxes.Item(Group_Boxes.Count - 1)
        Dim NewText As New TextBox
        NewText.Text = Name
        NewText.Location = New Point(6, y_Item)
        NewText.Multiline = (Size > 1)
        NewText.Height = 4 + (Size * 16)
        NewText.Width = box.Width - 12
        NewText.Anchor = AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top
        AddHandler NewText.Click, AddressOf TextClick
        box.Controls.Add(NewText)

        y_Item = NewText.Location.Y + NewText.Height + 6

        Dim opt As New OptionItem
        opt.Name = Name
        opt.TextControl = NewText

        Text_Boxes.Add(opt)

    End Sub

    Public Sub TextClick(ByVal sender As Object, ByVal e As System.EventArgs)
        DirectCast(sender, TextBox).SelectAll()
    End Sub

    Private Sub SupprtType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SupprtType.SelectedIndexChanged
        'MsgBox(DirectCast(sender, ComboBox).SelectedIndex)
        For Each gb As GroupBox In Group_Boxes
            gb.Visible = False
        Next
        Group_Boxes.Item(DirectCast(sender, ComboBox).SelectedIndex).Visible = True
    End Sub

    Private Sub Button_Copy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Copy.Click
        Dim CopyBuffer As String = SupprtType.SelectedItem + vbCr + vbCr
        For Each oi As OptionItem In Text_Boxes
            If oi.TextControl.Visible Then
                If oi.TextControl.Text = oi.Name Then Continue For
                CopyBuffer = CopyBuffer + oi.Name + vbCr
                CopyBuffer = CopyBuffer + oi.TextControl.Text + vbCr + vbCr
            End If
        Next
        Clipboard.SetText(CopyBuffer)
        Copied = True
    End Sub

    Private Sub Button_Reset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Reset.Click
        If Not Copied AndAlso MsgBox("Reset form?", MsgBoxStyle.YesNo, "Not copied") = MsgBoxResult.No Then Return
        For Each op In Text_Boxes
            op.TextControl.Text = op.Name
        Next
        Copied = False
    End Sub
End Class
